import java.awt.Point;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

record ShipData (int size, String name){
}

public class Ship {
	static List<List<ShipData>> semeterList = Arrays.asList(Arrays.asList(
																	new ShipData(2, "PRG 1"),
																	new ShipData(2, "GDI"),
																	new ShipData(2, "MAT 1"),
																	new ShipData(2, "THI"),
																	new ShipData(4, "STP"),
																	new ShipData(6, "ENG")),
															Arrays.asList(
																	new ShipData(2, "PRG 2"),
																	new ShipData(2, "DBS 1"),
																	new ShipData(2, "MAT 2"),
																	new ShipData(2, "STA"),
																	new ShipData(2, "AUD")),
															Arrays.asList(
																	new ShipData(2, "PRG 3"),
																	new ShipData(2, "DBS 2"),
																	new ShipData(2, "MAT 3"),
																	new ShipData(2, "BSN 1"),
																	new ShipData(4, "PRP"),
																	new ShipData(6, "BWL")),
															Arrays.asList(
																	new ShipData(2, "WEB"),
																	new ShipData(2, "SE 1"),
																	new ShipData(2, "CG 1"),
																	new ShipData(2, "BSN 2"),
																	new ShipData(4, "SEM"),
																	new ShipData(6, "E BWL")),
															Arrays.asList(
																	new ShipData(2, "WPF 1"),
																	new ShipData(2, "SE 2"),
																	new ShipData(2, "CG 2"),
																	new ShipData(2, "PXP 1"),
																	new ShipData(6, "EF 1")),
															Arrays.asList(
																	new ShipData(2, "WPF 2"),
																	new ShipData(1, "PXP 2"),
																	new ShipData(8, "BAA"))
	);

	private int size;
	private boolean horizontal;
	private Point position;
	private String name;
	private int hitsOnMe;
	private boolean sunk;

	public Ship (int size, String name) {
		this.size = size;
		this.name = name;
		this.horizontal = false;
		this.position = null;
		this.hitsOnMe = 0;
		this.sunk = false;
	}
	
	public boolean setPosition(Point pos) {
		//TODO Conte abrfrage ob shif da sein darf
		this.position = pos;
		return true;
	}

	public Point getPosition() {
		return position;
	}

	public boolean isShipOnPos(Point pos){
		if ((this.horizontal && pos.y == this.position.y && pos.x >= this.position.x && pos.x < this.position.x + size) ||
			(!(this.horizontal) && pos.x == this.position.x && pos.y >= this.position.y && pos.y < this.position.y + size)) {
			return true;
		}
		return false;
	}

	public HitResponseType shootOnShip(Point pos) {
		if (this.isShipOnPos(pos)) {
			hitsOnMe++;
			if (hitsOnMe >= size) {
				this.sunk = true;
				return HitResponseType.SUNK;
			}  else {
				return HitResponseType.HIT;
			}
		} else {
			return HitResponseType.MISS;
		}
	}

	public boolean isSunk() {
		return sunk;
	}
}
